const { fetch } = require("undici")
const express = require("express")
const app = express()
const chalk = require('chalk');
const { log } = console;
const time = new Date();
const { Database } = require('secure-db');
const db = new Database('main');
const date = time.toLocaleString("pt-BR", {timeZone: "America/Sao_Paulo"});
module.exports = {
  async cloud(url, interval) {
    if(!url) return "[ ❌ | ReplCloud  ] No url provided.";
    const isValidUrl = (str) => {
      try{
        new URL(str)
      } catch {
        return false
      }
      return true
    }
    if(!isValidUrl(url) || ["<", ">", "<script>", "</script>"].includes(url) || ["%3C", "%3E", "%20"].includes(encodeURIComponent(url))) return `[ ❌ | ReplCloud ] The project url is not valid\n[ 🔴 ] Offline`;
    
    const i = interval || 80000;

    setInterval( async () => {
      const res = await fetch(url, {
        headers : { 'User-Agent': 'replcloud-server (NPM Package)'}
      }).catch((err) => `[ ⛔ | ReplCloud ] an error occurred during the UpTimer\n[ ❌ | ReplCloud ] Ping failed\n[ ⛔ ] Stopped by error`)
     `[ 🟢 | Replcloud ] UpTimer ping on repl-server\n[ 🟢 ] Online`;
    }, i);
  },
  async replserver (port) {
    const status = 200;
    const PORT = port || 3000;
    app.get('*', (req, res) => {
    res.status(status).send(`ReplCloud Online`);
    })
    app.listen(PORT, () => log(chalk.green(`[ 🟢 | ReplCloud ] Webserver listening on the port ${port || 3000} [${date}]`)))
  },
  
async stats(url) {
var ping = Math.floor(10 * Math.random() + 1);
if (ping === 5) {
"[ ➖ | ReplCloud ] Logs not loaded, try again\n[ ➖ | ReplCloud ] Logs not loaded, try again\n[ ➖ | ReplCloud ] Logs not loaded, try again"
}
if (ping === 2) {
"[ 🟢 | Replcloud ] UpTimer ping on repl-server\n[ 🟢 ] Online"
}
if (ping === 3) {
"[ 🟢 | Replcloud ] UpTimer ping on repl-server"
}
if (ping === 4) {
"[ 🟢 | Replcloud ] UpTimer ping on repl-server\n[ 🟢 ] Online\n[ 🟢 | Replcloud ] UpTimer ping on repl-server\n[ 🟢 ] Online\n[ 🟢 | Replcloud ] UpTimer ping on repl-server\n[ 🟢 ] Online"
}
if (ping === 5) {
"[ ➖ | ReplCloud ] Logs not loaded, try again"
   }
if (ping === 6) {
"[ ➖ | ReplCloud ] Full logs we're clearing"
   }
  
}
